unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, TransparentesFenster;

type
  CatchAtr = record
   Time : integer;
   X : real;
   Y : real;
   dir : real;
  end;
  TCatcher = class(TForm)
    PaintBoxCatcher : TPaintBox;
    procedure Free(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OnIdle(Sender: TObject; var done : Boolean);
    procedure BoxIn;
    procedure BoxOut;
    procedure Ausblenden(Timekey : integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
 procedure Move (Timekey : integer);
 procedure Render;
 procedure CheckIfOver;
 procedure Draw;

var
  Catcher : TCatcher;
  Catched : integer = 0;
  Catch : CatchAtr;
  ClearSwitch : integer = 0;
  Open : integer = 0;
  Smile : integer = 0;
  AusblendTrans : integer = 2000;

implementation

{$R *.dfm}

procedure TCatcher.FormShow(Sender: TObject);
var 
  HR: HRgn; 
  p:array[0..3] of TPoint; 
begin 
  p[0]:=Point(Width div 2,1); 
  p[1]:=Point(1, Height div 2); 
  p[2]:=Point(Width div 2,Height); 
  p[3]:=Point(Width, Height div 2); 
  HR:= CreateEllipticRgn (0, 0, Width, Height); 
  SetWindowRgn(Handle, HR, True);
  Application.OnIdle := OnIdle;
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure Move (Timekey : integer);
var CursorPos : TPoint;
begin
 GetCursorPos(CursorPos);
 Catch.X := Catch.X + Timekey / 5 * cos(Catch.dir * (pi / 180));
 Catch.Y := Catch.Y - Timekey / 5 * sin(Catch.dir * (pi / 180));
 Catch.dir := arctan((catch.Y - CursorPos.Y) / (CursorPos.X - Catch.X)) * (180 / pi);
 if (CursorPos.X < Catch.X) then Catch.dir := Catch.dir + 180;
end;

procedure Render;
begin
 Catcher.Top := round(Catch.Y) - 25;
 Catcher.Left := round(Catch.X) - 25;
 Draw;
end;

procedure Draw;
var face : array[0..11] of TPoint;
    i : integer;
    cash : integer;
begin;
 if (Catched = 0) then begin
  face[0].X := 45;
  face[0].Y := 10;
  face[1].X := 23;
  face[1].Y := 20;
  face[2].X := 50;
  face[2].Y := 15;

  face[3].X := 270;
  face[3].Y := 7;
  face[4].X := 337;
  face[4].Y := 35;
  if (Open + 1000 < abs(getTickCount)) then Open := getTickCount;
  if (Open + 500 < abs(getTickCount)) then face[5].X := 280
  else face[5].X := 330;
  face[5].Y := 35;

  face[6].X := 120;
  face[6].Y := 20;
  face[7].X := 150;
  face[7].Y := 20;

  face[8].X := 150;
  face[8].Y := 20;
  face[9].X := 180;
  face[9].Y := 20;

  face[10].X := 180;
  face[10].Y := 20;
  face[11].X := 210;
  face[11].Y := 20;

  i := 0;
  while (i <= 11) do begin
   cash := face[i].Y;
   face[i].Y := round(sin((- face[i].X - catch.dir ) * (pi / 180)) * face[i].Y) + 25;
   face[i].X := round(cos((- face[i].X - catch.dir ) * (pi / 180)) * cash) + 25;
   i := i + 1;
  end;
  if (ClearSwitch + 100 < abs(getTickCount)) then begin
   Catcher.PaintBoxCatcher.Invalidate;
   ClearSwitch := getTickCount;
  end;

  Catcher.PaintBoxCatcher.Canvas.Polygon([face[0],face[1],face[2]]);
  Catcher.PaintBoxCatcher.Canvas.Polygon([face[3],face[4],face[5]]);
  Catcher.PaintBoxCatcher.Canvas.PolyLine([face[6],face[7]]);
  Catcher.PaintBoxCatcher.Canvas.PolyLine([face[8],face[9]]);
  Catcher.PaintBoxCatcher.Canvas.PolyLine([face[10],face[11]]);
 end;
 if (Catched = 1) then if (Smile + 100 < abs(getTickCount)) then begin
  face[0].X := 30;
  face[0].Y := 20;
  face[1].X := 40;
  face[1].Y := 20;
  face[2].X := 40;
  face[2].Y := 15;

  face[3].X := 20;
  face[3].Y := 20;
  face[4].X := 10;
  face[4].Y := 20;
  face[5].X := 10;
  face[5].Y := 15;

  face[6].X := 10;
  face[6].Y := 30;
  face[7].X := 20;
  face[7].Y := 35;

  face[8].X := 20;
  face[8].Y := 35;
  face[9].X := 30;
  face[9].Y := 35;

  face[10].X := 30;
  face[10].Y := 35;
  face[11].X := 40;
  face[11].Y := 30;

  Catcher.PaintBoxCatcher.Canvas.Rectangle(0,0,49,49);
  Catcher.PaintBoxCatcher.Canvas.Polygon([face[0],face[1],face[2]]);
  Catcher.PaintBoxCatcher.Canvas.Polygon([face[3],face[4],face[5]]);
  Catcher.PaintBoxCatcher.Canvas.Polygon([face[6],face[7]]);
  Catcher.PaintBoxCatcher.Canvas.Polygon([face[8],face[9]]);
  Catcher.PaintBoxCatcher.Canvas.Polygon([face[10],face[11]]);

  Smile := getTickCount;
 end;
 if (Catched = 2) then if (Smile + 100 < abs(getTickCount)) then begin
  face[0].X := 30;
  face[0].Y := 15;
  face[1].X := 40;
  face[1].Y := 20;

  face[2].X := 10;
  face[2].Y := 15;
  face[3].X := 20;
  face[3].Y := 20;

  face[4].X := 24;
  face[4].Y := 22;
  face[5].X := 24;
  face[5].Y := 27;

  face[6].X := 20;
  face[6].Y := 30;
  face[7].X := 30;
  face[7].Y := 35;

  Catcher.PaintBoxCatcher.Canvas.Rectangle(0,0,49,49);
  Catcher.PaintBoxCatcher.Canvas.Rectangle(face[0].X,face[0].Y,face[1].X,face[1].Y);
  Catcher.PaintBoxCatcher.Canvas.Rectangle(face[2].X,face[2].Y,face[3].X,face[3].Y);
  Catcher.PaintBoxCatcher.Canvas.PolyLine([face[4],face[5]]);
  Catcher.PaintBoxCatcher.Canvas.Ellipse(face[6].X,face[6].Y,face[7].X,face[7].Y);

  Smile := getTickCount;
 end;
end;

procedure TCatcher.BoxIn;
var Box : TRect;
begin
 box.top := Catcher.top + 20;
 box.left := Catcher.left + 20;
 box.right := Catcher.left + 30;
 box.bottom := Catcher.top + 30;
 ClipCursor(@Box);
 screen.Cursor := crNone;
 SetForegroundWindow(Catcher.Handle);
end;

procedure TCatcher.BoxOut;
var Box : TRect;
begin
 box.top := 100;
 box.left := 100;
 box.right := 90;
 box.bottom := 90;
 ClipCursor(@Box);
 screen.Cursor := crdefault;
end;

procedure CheckIfOver;
var CursorPos : TPoint;
begin
 GetCursorPos(CursorPos);
 if ((CursorPos.X - Catch.X) * (CursorPos.X - Catch.X) + (CursorPos.Y - Catch.Y) * (CursorPos.Y - Catch.Y) <= 625) then Catched := 1;
end;

procedure TCatcher.Ausblenden(Timekey : integer);
begin
 AusblendTrans := AusblendTrans - Timekey;
 if (AusblendTrans <= 0) then close
 else SetWindowTransparency(Round(AusblendTrans / 7.84313726),Handle);
end;

procedure TCatcher.OnIdle(Sender: TObject; var done : Boolean);
var Timekey : integer;
begin
 Timekey := abs(getTickCount) - Catch.Time;
 Catch.Time := getTickCount;
 if (Catched = 0) then begin
  Move(Timekey);
  CheckIfOver;
 end;
 if (Catched = 1) then BoxIn;
 if (Catched = 2) then begin
  BoxOut;
  Ausblenden(Timekey);
 end;
 Render;
 done := false;
end;

procedure TCatcher.FormCreate(Sender: TObject);
begin
 Catch.Y := Round(screen.Height / 2);
 Catch.X := Round(screen.Width / 2);
 Catch.dir := 0;
 Catch.Time := getTickCount;
 Render;
end;

procedure TCatcher.Free(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Catched := 2;
 SetCursorPos(Left + 25,Top + 30);
end;

end.
